﻿Imports System.IO
Public Class MisImpreciones
    Friend NombreArchivoParaImpresora As String
    Private MiPrintPreviewDialog As PrintPreviewDialog
    Private MiPrintDialog As PrintDialog
    Private WithEvents MiPrintDocument As System.Drawing.Printing.PrintDocument
    Private MiDoc As StreamReader

    Private Sub MiPrintDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles MiPrintDocument.PrintPage
        Dim Ligne As String
        Dim Position As System.Drawing.PointF
        Dim Rectangle As RectangleF
        Dim Police As Font = Nothing
        Dim AlturaLinea As Single
        Static NumeroPagina As Integer = 0

        Dim NumeroLinea As Integer = 0
        Dim TopPrecedente As Integer = e.MarginBounds.Top

        Dim SeparadorSplit As Char() = {"~"}
        Dim LosCampos() As String   ' Este es un tabla de String
        Dim LineaParaImpresora As String

        NumeroPagina += 1

        Do Until MiDoc.Peek = -1               ' Leer el archivo linea por linea 

            Ligne = MiDoc.ReadLine()   ' Leer una linea 

            '         If Linea = String.Empty Then Exit While
            LosCampos = Ligne.Split(SeparadorSplit)

            ' Aquí son las posibilidades de ajustar formato. Este es el mas difficile.

            If (NumeroLinea = 0 And NumeroPagina = 1) Or LosCampos(1) = "" Then
                Police = New Font("Courier New", 16, FontStyle.Bold)
            Else
                Police = New Font("Courier New", 12, FontStyle.Regular)
            End If

            LineaParaImpresora = ""

            ' Aquí es posible aqui de formatar los espaciados ente los informaciones

            For C As Integer = 0 To LosCampos.Length - 1
                LineaParaImpresora &= LosCampos(C) & "     "
            Next

            AlturaLinea = Police.GetHeight(e.Graphics)
            TopPrecedente += AlturaLinea
            Position = New PointF(e.MarginBounds.Left, TopPrecedente)
            Rectangle.Location = Position
            e.Graphics.DrawString(LineaParaImpresora, Police, Brushes.Black, Rectangle)

            NumeroLinea += 1

            If NumeroLinea = 1 And NumeroPagina = 1 Then  ' Subrayar los titulos 
                e.Graphics.DrawLine(Pens.Black, e.MarginBounds.Left, TopPrecedente + AlturaLinea, e.MarginBounds.Right, TopPrecedente + AlturaLinea)
            End If

            If TopPrecedente + AlturaLinea > e.MarginBounds.Height Then Exit Do
        Loop

        If MiDoc.Peek <> -1 Then
            e.HasMorePages = True
        Else
            MiDoc.Close()
            MiDoc = New StreamReader(NombreArchivoParaImpresora)
        End If
    End Sub

    Private Sub MisImpreciones_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        MiPrintDialog.Dispose()
        MiPrintPreviewDialog.Dispose()
        MiDoc.Close()
    End Sub

    Private Sub MisImpreciones_Load(sender As Object, e As EventArgs) Handles Me.Load
        If NombreArchivoParaImpresora = String.Empty OrElse Not File.Exists(NombreArchivoParaImpresora) Then
            Me.Close()
        End If
        MiPrintPreviewDialog = New PrintPreviewDialog
        MiPrintDialog = New PrintDialog
        MiPrintDocument = New System.Drawing.Printing.PrintDocument
        Dim Resultado As DialogResult
        MiPrintDialog.Document = MiPrintDocument  ' Elimimar 3 lineas si no seleccion del la impresora
        Resultado = MiPrintDialog.ShowDialog()
        If Resultado = Windows.Forms.DialogResult.OK Then
            MiPrintPreviewDialog.Document = MiPrintDocument
            MiPrintDocument.DocumentName = NombreArchivoParaImpresora
            MiDoc = New StreamReader(MiPrintDocument.DocumentName)
            MiPrintPreviewDialog.Dock = DockStyle.Fill
            Resultado = MiPrintPreviewDialog.ShowDialog()
            If Resultado = Windows.Forms.DialogResult.OK Then
                MiDoc.Close()
                MiDoc.Dispose()
            Else
                Me.Close()
            End If
        End If
    End Sub
End Class


